<template>
  <el-select
    v-model="selected"
    @change="onChange"
    placeholder="Целевая аудитория"
    remote
    filterable
    collapse-tags
    reserve-keyword
  >
    <el-option
      v-for="tvr in tvrs"
      :key="tvr.id"
      :label="tvr.name"
      :value="tvr.id"
    >
      <span class="name">{{ tvr.name }}</span>
      <span class="id">{{ tvr.id }}</span>
    </el-option>
  </el-select>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import ComponentMixin from "@/components/common/ComponentMixin";
import { Audience } from "@/interfaces/Audience";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";
import { AxiosResponse } from "axios";
import { AxiosInstance } from "@/modules/AxiosInstance";

/**
 * Компонент выбора аудитороии.
 */
@Component
export default class BaseAudiencesComponent extends Mixins(ComponentMixin) {
  // Id выбранной аудитории
  private selected: number | null = null;
  // Коллекция аудиторий
  private tvrs: Audience[] = [];

  /**
   * Метод вызывается после создания компонента.
   */
  protected created(): void {
    this.getTvr();
  }

  /**
   * Метод запроса целевой аудитории.
   */
  @AsyncRequestCatchException
  async getTvr(): Promise<void> {
    // Отправляем запрос
    const response: AxiosResponse = await AxiosInstance.get(
      "/channels/get-audiences"
    );
    // Если нет данных - завершаем выполнение метода
    if (!response.data) return;
    // Сохраняем новую коллекцию аудиторию
    this.tvrs = response.data as Audience[];
  }

  /**
   * Метод срабатывает после выбора аудитории
   */
  private onChange(): void {
    // Оповещаем другие компоненты об изменении коллекции выбранной аудитории
    this.notify("selected-tvr-id", this.selected);
  }
}
</script>

<style lang="scss" scoped>
.el-select {
  width: 100%;
  margin-bottom: 2%;
}
.id {
  float: right;
  color: #8492a6;
  font-size: 11px;
  margin-right: 15px;
}
.name {
  float: left;
  margin-right: 15px;
}
</style>
